Part Part2DObject
Introduction
A Part Part2DObject, or formally a Part::Part2DObject
, is a simple element with a topological shape that can be displayed in the 3D view.
The Part::Part2DObject
is derived from the Part Feature, but is specialized for 2D geometry, given that its shape will lie on a plane. This plane is defined by its DataPlacement property (position, normal, and rotation). However, the plane can also be defined by supporting geometrical elements, such as the plane created by three arbitrary vertices, or a face of a solid body.
Simplified diagram of the relationships between the core objects in FreeCAD
Usage
The Part Part2DObject is an internal object, so it cannot be created from the graphical interface, only from the Python console as described in the Scripting section.
The Part::Part2DObject
is defined in the Part Workbench but can be used as the base class for scripted objects in all workbenches that produce 2D geometrical shapes. For example, it is the base object for sketches (Sketcher SketchObject), and for most objects created with the Draft Workbench.
Workbenches can add more properties to this basic element to produce an object with complex behavior.
Properties
See Property for all property types that scripted objects can have.
The Part Part2DObject (Part::Part2DObject
class) is derived from the Part Feature (Part::Feature
class) and inherits all its properties.
The Part Part2DObject also has the following additional properties in the property editor. Hidden properties can be shown by using the Show all command in the context menu of the property editor.
Data
Attachment
- Data (Hidden)Attacher Type (
String
): class name of the attach engine object driving the attachment. It defaults toAttacher::AttachEnginePlane
. - DataSupport (
LinkSubList
): it is the plane or face supporting the 2D geometry. It defaults to an empty list[]
. - DataMap Mode (
Enumeration
):Deactivated
by default. This property determines a plane which the object will use as reference for 2D geometry. Clicking on the ellipsis ... (three dots), to the right of the entry field starts the Part EditAttachment command that allows selecting the supporting plane by picking different elements in the 3D view. The different modes are:Deactivated
,Translate origin
,Object's XY
,Object's XZ
,Object's YZ
,Plane face
,Tangent to surface
,Normal to edge
,Frenet NB
,Frenet TN
,Frenet TB
,Concentric
,Revolution section
,Plane by 3 points
,Normal to 3 points
,Folding
,Inertia 2-3
,Align O-N-X
,Align O-N-Y
,Align O-X-Y
,Align O-X-N
,Align O-Y-N
,Align O-Y-X
. - DataMap Reversed (
Bool
): it defaults tofalse
; if it istrue
the Z direction will be reversed. For example, a sketch will be flipped upside down. Hidden if DataMap Mode isDeactivated
. - Data (Hidden)Map Path Parameter (
Float
): sets point of curve to map a sketch to. It goes from0
to1
, which corresponds to thestart
andend
. It defaults to0
. - DataAttachment Offset (
Placement
): the position of the object in the 3D view, with respect to the attachment object's placement. The placement is defined by aBase
point (vector), and aRotation
(axis and angle). See Placement. Hidden if DataMap Mode isDeactivated
.
Scripting
See also: FreeCAD Scripting Basics and scripted objects.
See Part Feature for the general information on adding objects to the document.
A Part2DObject is created with the addObject()
method of the document.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Part::Part2DObject", "Name")
obj.Label = "Custom label"
For Python subclassing you should create a Part::Part2DObjectPython
object.
import FreeCAD as App
doc = App.newDocument()
obj = App.ActiveDocument.addObject("Part::Part2DObjectPython", "Name")
obj.Label = "Custom label"
- Core: App DocumentObject
- Basic: App FeaturePython, App GeoFeature, Part Feature, Mesh Feature, Fem FemMeshObject
- Internal shapes: Part TopoShape, Mesh MeshObject, Fem FemMesh
- Structure: App DocumentObjectGroup (Std Group), App Part (Std Part), App Link (Std LinkMake)
- Derived: Part Part2DObject, Sketcher SketchObject, PartDesign Body, PartDesign Feature

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub